package com.apg.eas.global.properties;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.PropertySource;
import org.springframework.context.support.PropertySourcesPlaceholderConfigurer;
import org.springframework.stereotype.Component;

@Component
@PropertySource("classpath:global.properties")
/*@PropertySource("file:C://MonitoringConfig//global.properties")*/

public class GlobalProperties {

	@Value("${jNDIProviderContextFactory}")
	private String jNDIProviderContextFactory;
	
	@Value("${jNDIProviderURL}")
	private String jNDIProviderURL;
	
	@Value("${jNDIUserName}")
	private String jNDIUserName;
	
	@Value("${jNDIPassword}")
	private String jNDIPassword;
	
	@Value("${jMSUserName}")
	private String jMSUserName;
	
	@Value("${jMSPassword}")
	private String jMSPassword;
	
	@Value("${topicConnectionFactory}")
	private String topicConnectionFactory;
	
	@Value("${jmsTopicName}")
	private String jmsTopicName;
	
	@Value("${jmxTopicName}")
	private String jmxTopicName;
	
	@Value("${PubSubUrl}")
	private String pubSubUrl;
	
	@Value("${JMXPortsCSVlocation}")
	private String jmxPortsCSVlocation;
	
	@Value("${EMSServerDetailslocation}")
	private String emsServerDetailslocation;
	
	@Value("${warnOnHeapMemUtilizationPercentage}")
	private Long warnOnHeapMemUtilizationPercentage;
	
	public String getJmsTopicName() {
		return jmsTopicName;
	}

	public void setJmsTopicName(String jmsTopicName) {
		this.jmsTopicName = jmsTopicName;
	}

	public String getJmxTopicName() {
		return jmxTopicName;
	}

	public void setJmxTopicName(String jmxTopicName) {
		this.jmxTopicName = jmxTopicName;
	}

	@Value("${fileDirectory}")
	private String fileDirectory;

	@Value("${fileArchiveDirectory}")
	private String fileArchiveDirectory;
	
	@Value("${emsTimeInterval}")
	private Long emsTimeInterval;
	
	@Value("${jmxTimeInterval}")
	private Long jmxTimeInterval;
	
	public Long getEmsTimeInterval() {
		return emsTimeInterval;
	}

	public void setEmsTimeInterval(Long emsTimeInterval) {
		this.emsTimeInterval = emsTimeInterval;
	}

	public Long getJmxTimeInterval() {
		return jmxTimeInterval;
	}

	public void setJmxTimeInterval(Long jmxTimeInterval) {
		this.jmxTimeInterval = jmxTimeInterval;
	}

	public String getjNDIProviderContextFactory() {
		return jNDIProviderContextFactory;
	}

	public void setjNDIProviderContextFactory(String jNDIProviderContextFactory) {
		this.jNDIProviderContextFactory = jNDIProviderContextFactory;
	}

	public String getjNDIProviderURL() {
		return jNDIProviderURL;
	}

	public void setjNDIProviderURL(String jNDIProviderURL) {
		this.jNDIProviderURL = jNDIProviderURL;
	}

	public String getjNDIUserName() {
		return jNDIUserName;
	}

	public void setjNDIUserName(String jNDIUserName) {
		this.jNDIUserName = jNDIUserName;
	}

	public String getjNDIPassword() {
		return jNDIPassword;
	}

	public void setjNDIPassword(String jNDIPassword) {
		this.jNDIPassword = jNDIPassword;
	}

	public String getjMSUserName() {
		return jMSUserName;
	}

	public void setjMSUserName(String jMSUserName) {
		this.jMSUserName = jMSUserName;
	}

	public String getjMSPassword() {
		return jMSPassword;
	}

	public void setjMSPassword(String jMSPassword) {
		this.jMSPassword = jMSPassword;
	}

	public String getTopicConnectionFactory() {
		return topicConnectionFactory;
	}

	public void setTopicConnectionFactory(String topicConnectionFactory) {
		this.topicConnectionFactory = topicConnectionFactory;
	}

	public String getFileDirectory() {
		return fileDirectory;
	}

	public void setFileDirectory(String fileDirectory) {
		this.fileDirectory = fileDirectory;
	}

	public String getFileArchiveDirectory() {
		return fileArchiveDirectory;
	}

	public void setFileArchiveDirectory(String fileArchiveDirectory) {
		this.fileArchiveDirectory = fileArchiveDirectory;
	}

	public Long getWarnOnHeapMemUtilizationPercentage() {
		return warnOnHeapMemUtilizationPercentage;
	}

	public void setWarnOnHeapMemUtilizationPercentage(Long warnOnHeapMemUtilizationPercentage) {
		this.warnOnHeapMemUtilizationPercentage = warnOnHeapMemUtilizationPercentage;
	}
	
	public String getPubSubUrl() {
		return pubSubUrl;
	}

	public void setPubSubUrl(String pubSubUrl) {
		this.pubSubUrl = pubSubUrl;
	}
	public String getEmsServerDetailslocation() {
		return emsServerDetailslocation;
	}

	public void setEmsServerDetailslocation(String emsServerDetailslocation) {
		this.emsServerDetailslocation = emsServerDetailslocation;
	}

	public String getJmxPortsCSVlocation() {
		return jmxPortsCSVlocation;
	}

	public void setJmxPortsCSVlocation(String jmxPortsCSVlocation) {
		this.jmxPortsCSVlocation = jmxPortsCSVlocation;
	}
		
	//utility method to convert the list to map
	/*private HashMap<String, String> convertListToMap(List<String> list)
	{
		HashMap<String, String> retMap = new HashMap<String, String>();
	    
		if (list != null && list.size() != 0) 
		{
	        for (String field : list) 
	        {
	            String[] splittedField = field.split("=");
	            retMap.put(splittedField[0], splittedField[1]);
	        }
	    }
		return retMap;
	}*/
	
	//To resolve ${} in @Value
	@Bean
	public static PropertySourcesPlaceholderConfigurer propertyConfigInDev() {
		return new PropertySourcesPlaceholderConfigurer();
	}

}