package com.apg.eas.resttemplate;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.springframework.http.converter.StringHttpMessageConverter;
import org.springframework.http.converter.json.MappingJackson2HttpMessageConverter;
import org.springframework.web.client.RestTemplate;

public class RestClient {

	public static void main1(String[] args) {
        int N = 77777777;
        long t;

        {
            StringBuffer sb = new StringBuffer();
            t = System.currentTimeMillis();
            for (int i = N; i --> 0 ;) {
                sb.append("");
            }
            System.out.println(System.currentTimeMillis() - t);
        }

        {
            StringBuilder sb = new StringBuilder();
            t = System.currentTimeMillis();
            for (int i = N; i --> 0 ;) {
                sb.append("");
            }
            System.out.println(System.currentTimeMillis() - t);
        }
    }
	
	public static void main(String args[]) 
	{
		Map<String, String> vars = new HashMap<String, String>();
		StringBuilder publishers = new StringBuilder();
		StringBuilder subsribers = new StringBuilder();
		RestTemplate rt = new RestTemplate();
		rt.getMessageConverters().add(new MappingJackson2HttpMessageConverter());
		rt.getMessageConverters().add(new StringHttpMessageConverter());
		String uri = new String("http://auapgdvtibapp04.genpt.net:8080/searchutil/FindDependencies");

		FindDependencySubReq subReq = new FindDependencySubReq();
		subReq.setActType("JMS");
		subReq.setConURL("");
		subReq.setDestination("DEV.GPC.NAM.PS.LOCATIONVAR.LOAD.TRIGGER.RCV.Q.V10");
		subReq.setDesType("queue");
		subReq.setDomainName("GPC_DEV_02");

		FindDependencyReq req = new FindDependencyReq();
		req.setCorrelationID("12344");
		req.setOperationName("getJMSInfo");
		req.setReq(subReq);

		FindDependencyRes res =  rt.postForObject(uri, req, FindDependencyRes.class, vars);
		//System.out.println("Correlation ID : " + res.getCorrelationID());
		//System.out.println("Operation Name : " + res.getOperationName());
		System.out.println("ContentObj : " + res.getContentobj());
		System.out.println("Result obj : " + res.getResult());
		
		for (Iterator iterator = res.getContentobj().iterator(); iterator.hasNext();)
		{
			FindDependencySubRes subRes = (FindDependencySubRes) iterator.next();
			if(subRes.getDirection().equals("Publisher"))
			{
				publishers.append(subRes.getAppName());
			}else
			{
				subsribers.append(subRes.getAppName());
			}
		}
		System.out.println("PUBLISHERS :" + publishers);
		System.out.println("SUBSCRIERS : " + subsribers);
		
	}
}
